#include <stdio.h>

int main() {

    int i;

    /* Data is an 8 byte array. */
    char data[8] = "aA42*";

    /* Various pointers for interpreting data array in various ways. */

    /* Interpret data as char data. */
    char *cPtr = data;

    /* Interpret data as int data. */
    int *iPtr = (int *) data;

    /* Interpret data as single-precision float data. */
    float *fPtr = (float *) data;

    printf("Size, in bytes, of primitive types\n");
    printf("    char: %d, int: %d, float: %d\n",
           sizeof(*cPtr), sizeof(*iPtr), sizeof(*fPtr));

    printf("\ndata as a string: |%s|\n", cPtr);

    printf("\ndata's bytes as characters and hexadecimal values\n");
    printf("showing each byte's index and memory address\n");
    for (i = 0; i < 8; i++, cPtr++)
        printf("    byte %2d @ 0X%llX: |%c|, 0X%hhX\n", i, cPtr, *cPtr, *cPtr);

    printf("\ndata's bytes as four byte ints\n");
    printf("showing each int's index and memory address\n");
    for (i = 0; i < 2; i++, iPtr++)
        printf("    int %2d @ 0X%llX: %d\n", i, iPtr, *iPtr);

    printf("\ndata's bytes as four byte floats\n");
    printf("showing each float's index and memory address\n");
    for (i = 0; i < 2; i++, fPtr++)
        printf("    float %2d @ 0X%llX: %g\n", i, fPtr, *fPtr);

    return 0;
}
